#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import time,uuid

from orm import Model,StringField,BooleanField,FloatField,TextField,IntegerField


def next_id():
    return '%015d%s000' % (int(time.time() * 1000),uuid.uuid4().hex)


class User(Model):
    __table__ = 'users'

    id = StringField(primary_key=True, default=next_id, ddl='varchar(50)')
    email = StringField(ddl='varchar(50)')
    passwd = StringField(ddl='varchar(50)')
    admin = BooleanField()
    name = StringField(ddl='varchar(50)')
    image = StringField(ddl='varchar(500)')
    created_at = FloatField(default=time.time)


class Project(Model):
    __table__ = 'projects'

    id = IntegerField(primary_key=True)
    name = StringField(ddl='varchar(50)')
    pid = IntegerField(default=0)
    created_at = FloatField(default=time.time)

class Website(Model):
    __table__ = 'websites'

    id = IntegerField(primary_key=True)
    name = StringField(ddl='varchar(50)')
    project_id = IntegerField()
    ismobile = BooleanField()
    sites = StringField(ddl='varchar(200)')
    created_at = FloatField(default=time.time)

class Pageurl(Model):
    __table__='pageurls'

    id = IntegerField(primary_key=True)
    name = StringField(ddl='varchar(50)')
    site_id = IntegerField()
    url = StringField(ddl='varchar(200)')
    created_at = FloatField(default=time.time)

class Blog(Model):
    __table__ = 'blogs'

    id = StringField(primary_key=True, default=next_id, ddl='varchar(50)')
    user_id = StringField(ddl='varchar(50)')
    user_name = StringField(ddl='varchar(50)')
    user_image = StringField(ddl='varchar(500)')
    name = StringField(ddl='varchar(50)')
    summary = StringField(ddl='varchar(200)')
    content = TextField()
    created_at = FloatField(default=time.time)


class Comment(Model):
    __table__ = 'comments'

    id = StringField(primary_key=True, default=next_id, ddl='varchar(50)')
    blog_id = StringField(ddl='varchar(50)')
    user_id = StringField(ddl='varchar(50)')
    user_name = StringField(ddl='varchar(50)')
    user_image = StringField(ddl='varchar(500)')
    content = TextField()
    created_at = FloatField(default=time.time)